Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 598535 - the gnome-keyring-daemon needs proper locking around memory allocations functions
Summary: the gnome-keyring-daemon needs proper locking around memory allocations funct...
Keywords:
Status: CLOSED UPSTREAM
Alias: None
Product: Fedora
Classification: Fedora
Component: gnome-keyring
Version: 13
Hardware: All
OS: Linux
low
medium
Target Milestone: ---
Assignee: Tomáš Bžatek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-06-01 15:16 UTC by Fabrice Bellet
Modified: 2015-03-03 22:49 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-06-29 16:51:07 UTC


Attachments (Terms of Use)
patch to add locking for memory ops in the gkd (deleted)
2010-06-01 15:18 UTC, Fabrice Bellet
no flags Details | Diff

Description Fabrice Bellet 2010-06-01 15:16:40 UTC
the gnome-keyring-daemon crashes frequently in egg-secure-memory.c, specifically when it is used as a ssh agent, with a lot of concurrent ssh sessions. The memory allocation functions in egg/egg-secure-memory.c are protected by DO_LOCK() / DO_UNLOCK() macros, with appear to be no-op in the case of the gnome-keyring-daemon (daemon/gkd-main.c), which is probably not a good idea, because it works in a threaded environment when creating client threads in gkd_ssh_agent_accept().

So I think a real locking should be added in daemon/gkd-main.c

patch is attached.

Comment 1 Fabrice Bellet 2010-06-01 15:18:00 UTC
Created attachment 418678 [details]
patch to add locking for memory ops in the gkd

Comment 2 Fabrice Bellet 2010-06-29 16:51:07 UTC
This is fixed in 2.30.3. thanks!


Note You need to log in before you can comment on or make changes to this bug.